import { world, ItemStack } from "@minecraft/server"

system.beforeEvents.watchdogTerminate.subscribe(eventData => {
	console.error("watchdog = " + eventData.terminateReason +
		" trying to cancel crash")
	eventData.cancel = true
})


const xp_bottle = new ItemStack("nk:xp_bottle", 1)
const minLevelNeeded = 26

world.afterEvents.playerInteractWithBlock.subscribe((data) => {
    const player = data.player
    const block = data.block.typeId
    if (block == "nk:xp_saver") {
        const inventory = player.getComponent("inventory")
        const item = inventory.container.getItem(player.selectedSlot)
        const playerLevel = player.level
        if (item != undefined) {                                    // elinde birzatlar bar bolsa
            if (playerLevel >= minLevelNeeded && item.typeId == "minecraft:lapis_lazuli") {
                if (inventory.container.emptySlotsCount >> 0) {     // eger inventarda yer bar bolsa
                    if (item.amount >> 1) {                         // 1den kop lapisi bar bolsa
                        const lapis = new ItemStack("lapis_lazuli", item.amount - 1)    // elinden 1 lapis aldyk
                        inventory.container.setItem(player.selectedSlot, lapis)         // elinden 1 lapis aldyk
                    } else {                                        // eger dine 1 lapisi bar bolsa
                        inventory.container.setItem(player.selectedSlot, undefined)     //1 lapisini aldyk
                    }
                    player.addLevels(-1)                            // 1 levelini aldyk
                    world.getDimension(player.dimension.id).runCommand(
                        `playsound cauldron.takewater ${player.name} ${player.location.x} ${player.location.y} ${player.location.z} 9 3 2`)
                    inventory.container.addItem(xp_bottle)          // 1 xp bottle berdik
                } else {                                            // eger inventarda yer yok bolsa
                    if (item.amount >> 1) {                         // 1den kop lapisi bar bolsa
                        let a = []                                                  // inventarinde ahli zatlaryn massivini doretdik                        
                        for (let index = 0; index < 36; index++) {                  // inventarinde ahli zatlaryn massivini doretdik
                            a.push(inventory.container.getItem(index).typeId)       // inventarinde ahli zatlaryn massivini doretdik
                            if (a[index] == "minecraft:experience_bottle") {        // inventarinde xp bottle bolan slot bar bolsa
                                if (inventory.container.getItem(index).amount << 64) {    // inventarinde 64 den az xp bottle bar bolsa
                                    const lapis = new ItemStack("lapis_lazuli", item.amount - 1)    // elinden 1 lapis aldyk
                                    inventory.container.setItem(player.selectedSlot, lapis)         // elinden 1 lapis aldyk
                                    player.addLevels(-1)                            // 1 levelini aldyk
                                    world.getDimension(player.dimension.id).runCommand(
                                        `playsound cauldron.takewater ${player.name} ${player.location.x} ${player.location.y} ${player.location.z} 9 3 2`)
                                    inventory.container.addItem(xp_bottle)          // 1 xp bottle berdik
                                }
                            }
                        }
                    }
                    else if (item.amount == 1) {                                      // eger dine 1 lapisi bar bolsa
                        inventory.container.setItem(player.selectedSlot, undefined) //1 lapisini aldyk
                        player.addLevels(-1)                                // 1 levelini aldyk
                        world.getDimension(player.dimension.id).runCommand(
                            `playsound cauldron.takewater ${player.name} ${player.location.x} ${player.location.y} ${player.location.z} 9 3 2`)
                        inventory.container.addItem(xp_bottle)              // 1 xp bottle berdik
                    }
                }
            } else {
                player.onScreenDisplay.setActionBar(`§6§lEn azından ${minLevelNeeded} seviye ve Elinde Lapis ile tıklaman gerekiyor!!!§r`)
            }
        } else {
            player.onScreenDisplay.setActionBar(`§6§lEn azından ${minLevelNeeded} seviye ve Elinde Lapis ile tıklaman gerekiyor!!!§r`)
        }
    }
})
world.afterEvents.itemUseOn.subscribe((data) => {
    const player = data.source
    const item = data.itemStack.typeId
    const inventory = player.getComponent("inventory").container
    if (item == "nk:xp_bottle") {
        if (inventory.getItem(player.selectedSlot).amount >> 1) {
            const xp_bottle_item = new ItemStack("nk:xp_bottle", inventory.getItem(player.selectedSlot).amount - 1)
            inventory.setItem(player.selectedSlot, xp_bottle_item)
        } else {
            inventory.setItem(player.selectedSlot, undefined)
        }
        player.addLevels(1)
        world.getDimension(player.dimension.id).runCommand(
            `playsound block.lantern.break ${player.name} ${player.location.x} ${player.location.y} ${player.location.z} 9 1 2`)
    }
})
world.afterEvents.itemUse.subscribe((data) => {
    const player = data.source
    const item = data.itemStack.typeId
    const inventory = player.getComponent("inventory").container
    if (item == "nk:xp_bottle") {
        if (inventory.getItem(player.selectedSlot).amount >> 1) {
            const xp_bottle_item = new ItemStack("nk:xp_bottle", inventory.getItem(player.selectedSlot).amount - 1)
            inventory.setItem(player.selectedSlot, xp_bottle_item)
        } else {
            inventory.setItem(player.selectedSlot, undefined)
        }
        player.addLevels(1)
        world.getDimension(player.dimension.id).runCommand(
            `playsound block.lantern.break ${player.name} ${player.location.x} ${player.location.y} ${player.location.z} 9 1 2`)
    }
})